Subject: Re: Confusion regarding user interpretations for times spanning midni ght

From: [email-masked]
Date: Tue, 14 Mar 2000 08:11:34 -0500

David,

I've been thinking about the question you've raised here, as well as
about the "first weekday of the month" question you raised in your
other note.  First, I'll start with a general comment:  while I can
appreciate your desire to keep your user interface implementation
simple and straightforward, I don't think this is the right design
overall.  At one end, you're starting with a human user, who is able
to think about times and time intervals very flexibly.  At the other
end, you have the PDP and PEP, which have to turn a policy rule on
and off at the correct times.  There has to be a mapping *somewhere*
between the flexible human representations of times and the concrete
behavior of turning the policy rule on and off.  In general, I think
this "somewhere" should be in the Policy Management Tool.

I'm very comfortable making this argument to support using the
existing schema in the way I indicated earlier for the "first weekday
of the month" schedule.  The question of times spanning midnight is a
little more of a gray area.  I can see the requirement for the type
of schedule you're interested in:  start at 22:00 on a set of
specified days, and stop 6 hours later in each case.  It wouldn't be
hard to add something to the schema to indicate whether intervals
spanning midnight are to be interpreted this way, or in the way
they're currently specified in the document.  And it wouldn't take
a whole lot of additional code for the PDPs and PEPs (whichever one
is "consuming" the PTP Condition object in a particular case) to
support this new option.  Even in this case, though, I think the
better place to put the additional code is in the Policy Management
Tools:  there are fewer of them, they aren't busy with such mundane
tasks as routing packets, and it's easier to change them later when
new requirements emerge (remember when the futurists predicted that
by Y2K we'd all be working 30-hour weeks?:-).  Plus, doing it this
way lets people like you differentiate your Policy Management Tools
from their competitors, by providing more intuitive mappings between
human scheduling concepts and the PDP/PEP-friendly scheduling
representation in the schema.

Regards,
Bob

Bob Moore
IBM Networking Software
+1-919-254-4436
[email-masked]

"David Lowndes" <[email-masked]>@raleigh.ibm.com on 03/07/2000
09:07:55 AM

Please respond to "David Lowndes" <[email-masked]>

Sent by:  [email-masked]

To:   [email-masked]
cc:
Subject:  Confusion regarding user interpretations for times spanning midni
      ght

The draft-ietf-policy-core-info-model-03 document says this:

   When a range spans midnight, it by definition includes parts of two
   successive days.  When one of these days is also selected by either
   the MonthOfYearMask, DayOfMonthMask, and/or DayOfWeekMask, but the
   other day is not, then the policy is active only during the portion of
   the range that falls on the selected day.  For example, if the range
   extends from 2100 until 0800, and the day of week mask selects Monday
   and Tuesday, then the policy is active during the following three
   intervals:

       From midnight Sunday until 0800 Monday;
       From 2100 Monday until 0800 Tuesday;
       From 2100 Tuesday until 23:59:59 Tuesday.

This is a logical interpretation of the underlying attributes. However it's
not necessarily a logical interpretation for someone who has to enter and
maintain this data.

I should add that we have a 50:50 split in the interpretation of this
in-house. We all agree that the proposed standard is the simple way of
interpreting the underlying data, but half of us feel that it's misleading
from a user's perspective.

Given a slightly simpler example, to allow a policy to start on a Saturday
at 22:00 and finish on the Sunday at 4:00, a normal user would expect that
entering 2 items: a day mask of Saturday, and a time range of 220000:040000
would fully specify the range. After all, surely that is why you've allowed
times to span midnight?

Under the proposed standard interpretation this will actually mean that the
example policy is valid on 2 discontinuous time periods:

An unwanted period:     Saturday 000000:040000
A wanted period:                Saturday 220000:235959

Furthermore, to obtain the user's required time period they have to specify
2 periods: Saturday 220000:235959 and Sunday 000000:040000, which is rather
long-winded and not particularly intuitive. If this is case, we can't see
the point in allowing times to span midnight.

You could argue that it's not the standard's responsibility to be concerned
with user-interface issues. However, if the standard makes it impossible to
convey users intentions in an unambiguous manner, then we think it is a
matter of some concern.

Any thoughts?

David Lowndes